unit wymianadanych;

interface

uses Graphics, SysUtils, Windows, Math;

type

  TObiekt = class
    x,y : integer;
  end;

  TObserwator = class(TObiekt)
    zasieg : integer;
    procedure check;        // sprawdza pole widzenia w poszukiwaniu rekinw
  end;

  TCzlowiek = class(TObiekt)
    killed : boolean;
    procedure Move;     // porusza czlowieka
  end;

  TLodz = class(TObiekt)
    srcx,srcy : integer;
    destx,desty : integer;
    zasieg, predkosc : integer;
    dir : boolean;
    procedure check;   // sprawdza pole widzenia w poszukiwaniu rekinow
    procedure Move;    // porusza lodz
  end;

  TRekin = class(TObiekt)
    killed : boolean;
    seen : integer;
    procedure Move;   // porusza rekina
  end;

  TLiveForm = record
    czestosc,
    maxpop,
    predkosc,
    zasieg : integer;
  end;


var
  Map : TPicture;       // Obrazek duej mapy
  MiniMap : TPicture;   // Obrazek malej mapy
  Obserwator : TPicture;
  Lodka : TPicture;
  Rekin : TPicture;
  Plywa : TPicture;
  Idzie : TPicture;
  Rip : TPicture;
  canv : array[0..799,0..1199] of TColor;  // tablica kolorow pikseli duzej mapy

  alert : boolean; // jeeli plywa widoczny rekin

  obs : array of TObserwator;
  czl : array of TCzlowiek;
  lod : array of TLodz;
  rek : array of TRekin;

  rekiny,ludzie : TLiveForm;  // dane gatunkow

  px,py : integer;        // Wsplrzdne lewego grnego rogu okienka duej mapy
  krok, odswiezanie : integer;

  wiadomosci : array of string;

  loop : integer;  // numer iteracji petli watku TSymulacja

implementation

uses plazaUnit6;

{ TObserwator }

procedure TObserwator.check;
var i : integer;
    l : Real;
begin
  for i:=0 to Length(rek)-1 do if not rek[i].killed then
    begin
      l:=sqrt(sqr(rek[i].x-x)+sqr(rek[i].y-y));
      if l<=zasieg then
        begin
          alert:=true;
          if loop-rek[i].seen>1 then
            begin
              SetLength(wiadomosci,Length(wiadomosci)+1);
              wiadomosci[Length(wiadomosci)-1]:=
                floattostr(FTime/1000)+': obserwator na ('+inttostr(x)+','+inttostr(y)
                  +') dostrzeg rekina na ('+inttostr(rek[i].x)+','+inttostr(rek[i].y)+').';
            end;
          rek[i].seen:=loop;
        end
    end;
end;

{ TCzlowiek }

procedure TCzlowiek.Move;
var newx,newy : integer;
    q,i : integer;
    l : Real;
begin
  if killed then Exit;
  q:=round(ludzie.predkosc*krok/1000);
  newx:=x;
  newy:=y;
  if ({Map.Bitmap.Canvas.Pixels}canv[x,y]<>RGB(0,255,255)) and
    ({Map.Bitmap.Canvas.Pixels}canv[x,y]<>RGB(0,0,255)) then
      begin      // jeeli stoi na ziemi
        if not alert then  // i nie ma alertu
          begin
            newx:=x-q;  // to idzie si kapa
            newy:=y;
          end
      end
  else               // jeeli jest w wodzie
    begin
      if alert then  // i jest alert
        begin
          newx:=x+q;  // to pynie do brzegu
          newy:=y;
        end
      else              // jeeli nie ma alertu
        begin
          if random(2)=0 then newx:=x+random(q+1) else newx:=x-random(q+1);
          if random(2)=0 then newy:=y+random(q+1) else newy:=y-random(q+1);
          if x>200 then
            newx:=newx-random(round((x-200)/100)+1)
          else
            newx:=newx+random(round((200-x)/100)+1)
        end;
    end;
  for i:=0 to Length(rek)-1 do if not rek[i].killed then
    begin
      l:=sqrt(sqr(rek[i].x-x)+sqr(rek[i].y-y));
      if l<=ludzie.zasieg then               // jeeli widzi rekina
        begin
          if l<>0 then
            begin
              newx:=x+round((x-rek[i].x)*q/l);   // to ucieka w przeciwnym kierunku
              newy:=y+round((y-rek[i].y)*q/l);
            end
          else // sparaliowany przez straaaach
            begin
              newx:=x;
              newy:=y;
            end;
          Break;          // ludzie s gupi i uciekaj gdzie popadnie jak tylko zobacz rekina
        end;
    end;
  for i:=0 to Length(obs)-1 do
    if sqrt(sqr(obs[i].x-x)+sqr(obs[i].y-y))<10 then      // jeeli wpad na obserwatora to prbuje go omin
      begin
        newx:=x;
        if random(2)=0 then newy:=y+random(q+1) else newy:=y-random(q+1);
      end;
{  for i:=0 to length(czl)-1 do           // wpada na innego czowieka
    if czl[i]<>self then
      if sqrt(sqr(czl[i].x-x)+sqr(czl[i].y-y))<10 then
        begin
          newx:=x;
          newy:=y
        end;
  for i:=0 to Length(lod)-1 do                      // wpada na lodz
    if sqrt(sqr(lod[i].x-x)+sqr(lod[i].y-y))<10 then
      begin
        newx:=x;
        newy:=y
      end;   }
  if newx<0 then newx:=0;
  if newy<0 then newy:=0;
  if newx>Map.Width then newx:=Map.Width;
  if newy>Map.Height then newy:=Map.Height;
  x:=newx;
  y:=newy;
end;

{ TRekin }

procedure TRekin.Move;
var i : integer;
    newx,newy : integer;
    q : integer;
    l,ll : Real;
begin
  if killed then Exit;
  q:=round(rekiny.predkosc*krok/1000);
  if random(2)=0 then newx:=x+random(q+1) else newx:=x-random(q+1);
  if random(2)=0 then newy:=y+random(q+1) else newy:=y-random(q+1);
  ll:=rekiny.zasieg;
  for i:=0 to Length(czl)-1 do if not czl[i].killed then
    begin
      l:=sqrt(sqr(czl[i].x-x)+sqr(czl[i].y-y));
      if l<ll then
        begin
          ll:=l;
          if l<>0 then                           // rekiny nie s gupie tak jak ludzie i pdz do najbliszego
            begin
              newx:=x-round((x-czl[i].x)*q/l);
              newy:=y-round((y-czl[i].y)*q/l);
            end
          else
            begin
              newx:=x;
              newy:=y;
            end
        end
    end;
  // faza testowa
  if ({Map.Bitmap.Canvas.Pixels}canv[Newx,Newy]<>RGB(0,255,255)) and
    ({Map.Bitmap.Canvas.Pixels}canv[Newx,Newy]<>RGB(0,0,255)) then
      begin
        newx:=x;  // rekin nie moe pywa po ldzie
        newy:=y;
      end;
  if newx<0 then newx:=0;  // rekin nie moe wypyn poza map
  if newy<0 then newy:=0;
  if newx>Map.Width then newx:=Map.Width;
  if newy>Map.Height then newy:=Map.Height;
  x:=newx;
  y:=newy;
  // zeranie ludzi
  for i:=0 to Length(czl)-1 do if not czl[i].killed then
    begin
      l:=sqrt(sqr(czl[i].x-x)+sqr(czl[i].y-y));
      if l<15 then
        begin
          czl[i].killed:=true;
          dec(FCzl);
          inc(FCzlRip);
          SetLength(wiadomosci,Length(wiadomosci)+1);
          wiadomosci[Length(wiadomosci)-1]:=
            floattostr(FTime/1000)+': rekina na ('+inttostr(x)+','+inttostr(y)+
              ') zjad czowieka z pozycji ('+inttostr(czl[i].x)+','+inttostr(czl[i].y)+').';
        end;
    end;
end;

{ TLodz }

procedure TLodz.check;
var i : integer;
    l : Real;
begin
  for i:=0 to Length(rek)-1 do if not rek[i].killed then
    begin
      l:=sqrt(sqr(rek[i].x-x)+sqr(rek[i].y-y));
      if l<=zasieg then
        begin
          alert:=true;
          if loop-rek[i].seen>1 then
            begin
              SetLength(wiadomosci,Length(wiadomosci)+1);
              wiadomosci[Length(wiadomosci)-1]:=
                floattostr(FTime/1000)+': d na ('+inttostr(x)+','+inttostr(y)
                  +') dostrzega rekina na ('+inttostr(rek[i].x)+','+inttostr(rek[i].y)+').';
            end;
          rek[i].seen:=loop;
        end
    end;
end;

procedure TLodz.Move;
var i : integer;
    q : integer;
    newx,newy : integer;
    minl,l : Real;
begin
  q:=round(predkosc*krok/1000);;
  if dir then             // normalny tryb patrolowania
    begin
      l:=sqrt(sqr(x-destx)+sqr(y-desty));
      if l<>0 then
        begin
          newx:=x-round((x-destx)*q/l);
          newy:=y-round((y-desty)*q/l);
        end
      else
        begin
          newx:=x;
          newy:=y;
        end
    end
  else
    begin
      l:=sqrt(sqr(x-srcx)+sqr(y-srcy));
      if l<>0 then
        begin
          newx:=x-round((x-srcx)*q/l);
          newy:=y-round((y-srcy)*q/l);
        end
      else
        begin
          newx:=x;
          newy:=y;
        end
    end;
  // polowanie na najblizszego rekina;
  minl:=Power(10,100); // duo
  for i:=0 to Length(rek)-1 do
    if (loop-rek[i].seen<=1) and not rek[i].killed then
      begin
        l:=sqrt(sqr(x-rek[i].x)+sqr(y-rek[i].y));
        if l<minl then
          begin
            minl:=l;
            if l<>0 then
              begin
                newx:=x-round((x-rek[i].x)*q/l);
                newy:=y-round((y-rek[i].y)*q/l);
              end
            else
              begin
                newx:=x;
                newy:=y;
              end
          end
      end;
  // faza testowa
  if ({Map.Bitmap.Canvas.Pixels}canv[Newx,Newy]<>RGB(0,255,255)) and
    ({Map.Bitmap.Canvas.Pixels}canv[Newx,Newy]<>RGB(0,0,255)) then
      begin
        newx:=x;  // lodz nie moe pywa po ldzie
        newy:=y;
      end;
  if newx<0 then newx:=0;  // d nie moe wypyn poza map
  if newy<0 then newy:=0;
  if newx>799 then newx:=799;
  if newy>1199 then newy:=1199;
{  for i:=0 to length(czl)-1 do  // eby nie wpa na czowieka
    if sqrt(sqr(czl[i].x-x)+sqr(czl[i].y-y))<10 then
      begin
        newx:=x;
        newy:=y
      end; }
  x:=newx;
  y:=newy;
  // polowanie
  for i:=0 to Length(rek)-1 do if not rek[i].killed then
    begin
      l:=sqrt(sqr(rek[i].x-x)+sqr(rek[i].y-y));
      if l<15 then
        begin
          rek[i].killed:=true;
          dec(FRek);
          inc(FRekRip);
          SetLength(wiadomosci,Length(wiadomosci)+1);
          wiadomosci[Length(wiadomosci)-1]:=
            floattostr(FTime/1000)+': d na ('+inttostr(x)+','+inttostr(y)+
              ') zabia rekina na pozycji ('+inttostr(rek[i].x)+','+inttostr(rek[i].y)+').';
        end;
    end;
  // ewentualna zmiana kierunku;
  if (abs(x-srcx)<10) and (abs(y-srcy)<10) then dir:=true;
  if (abs(x-destx)<10) and (abs(y-desty)<10) then dir:=false;
end;

begin
  Map:=TPicture.Create;
  Map.LoadFromFile('plaza.bmp');
  MiniMap:=TPicture.Create;
  MiniMap.LoadFromFile('plazamini.bmp');
  Obserwator:=TPicture.Create;
  Obserwator.LoadFromFile('obserwator.bmp');
  Lodka:=TPicture.Create;
  Lodka.LoadFromFile('boat.bmp');
  Rekin:=TPicture.Create;
  Rekin.LoadFromFile('rekin.bmp');
  Plywa:=TPicture.Create;
  Plywa.LoadFromFile('plywa.bmp');
  Idzie:=TPicture.Create;
  Idzie.LoadFromFile('stoi.bmp');
  Rip:=TPicture.Create;
  Rip.LoadFromFile('rip.bmp');
  px:=0;
  py:=0;
  krok:=100;
  odswiezanie:=1000;
  alert:=false;
  SetLength(obs,0);
  SetLength(czl,0);
  SetLength(lod,0);
  SetLength(rek,0);
  rekiny.czestosc:=15;
  rekiny.maxpop:=5;
  rekiny.predkosc:=30;
  rekiny.zasieg:=300;
  ludzie.czestosc:=10;
  ludzie.maxpop:=40;
  ludzie.predkosc:=20;
  ludzie.zasieg:=50;
  Setlength(wiadomosci,0);
  loop:=0;
end.
